<div class="reserva-container">

  <h4>Productos reservados</h4>

  <ng-container *ngIf="reservas.length; else mensaje">
    <p-table #dt [value]="reservas" [rows]="10" [paginator]="true" [globalFilterFields]="['codigoReserva']"
      [tableStyle]="{ 'min-width': '75rem' }" [rowHover]="true" dataKey="id"
      currentPageReportTemplate="Mostrando {first} al {last} de {totalRecords} reservas" [showCurrentPageReport]="true">
      <ng-template pTemplate="caption">
        <div class="flex align-items-center justify-content-between">
          <span class="p-input-icon-right filtro">
            <i class="pi pi-search"></i>
            <input type="text" class="inpt_secon" (input)="busqueda($event)"
              placeholder="Buscar por código de reserva...">
          </span>

          <p-dropdown [options]="estados" class="inpt_secon w-pdd" (onChange)="filtrarReservas($event.value)"
            [showClear]="true" placeholder="Filtrar por estado" [(ngModel)]="estado">
          </p-dropdown>
        </div>
      </ng-template>
      <ng-template pTemplate="header">
        <tr>
          <th pSortableColumn="detalle.codigoReserva">Codigo<p-sortIcon field="codigoReserva"></p-sortIcon></th>
          <th pSortableColumn="Usuario">Cliente<p-sortIcon field="Usuario"></p-sortIcon></th>
          <th pSortableColumn="Producto">Producto<p-sortIcon field="Producto"></p-sortIcon></th>
          <th pSortableColumn="detalle.Reserva.FechaSolicitud">Fecha de reserva<p-sortIcon
              field="detalle.Reserva.FechaSolicitud"></p-sortIcon></th>
          <th pSortableColumn="detalle.Reserva.FechaEntrega">Fecha de recojo<p-sortIcon
              field="detalle.Reserva.FechaEntrega"></p-sortIcon></th>
          <th pSortableColumn="detalle.estado">Estado <p-sortIcon field="estado"></p-sortIcon></th>
          <th></th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-reserva let-i="index">
        <tr>
          <td>{{ reserva.detalle.CodigoReserva }}</td>
          <td>{{ reserva.Usuario }}</td>
          <td>{{ reserva.Producto }}</td>
          <td>{{ obtenerFecha(reserva.detalle.Reserva.FechaSolicitud) }}</td>
          <td>{{ obtenerFecha(reserva.detalle.Reserva.FechaEntrega) }}</td>
          <td>
            <span class="estado font-semibold" [class]="obtenerColorEstado(reserva.detalle.Estado)">
              {{ obtenerEstadoReserva(reserva.detalle.Estado) }}
            </span>
          </td>
          <td>
            <button pButton icon="pi pi-eye" class="btn p-button-rounded" pTooltip="Ver detalle de la reserva"
              tooltipPosition="left" (click)="mostrarDetalleReserva(reserva)"></button>
          </td>
        </tr>
      </ng-template>
      <ng-template pTemplate="summary">
        <div class="flex align-items-center justify-content-between">En total hay {{ reservas.length }} productos.</div>
      </ng-template>
    </p-table>
  </ng-container>

  <ng-template #mensaje>
    <div class="mensaje">
      <p>No se encontraron productos</p>
    </div>
  </ng-template>
</div>

<div class="dialog-container-general">
  <p-dialog header="Detalle de la reserva" [(visible)]="dialogDetalleReserva" [style]="{width: '40vw'}" [modal]="true"
    class="modal-container">
    <div class="detalleReserva">
      <div class="fila">
        <span><label>Codigo de reserva</label>{{ reserva.detalle.CodigoReserva }}</span>
      </div>

      <div class="fila">
        <span><label>Cliente</label>{{ reserva.Usuario }}</span>
        <span>
          <label>Celular:</label>
          <a class="link_style" href="https://wa.me/{{ reserva.Telefono}}" target="_blank">
            <i class="uil uil-whatsapp"></i> {{ reserva.Telefono }}
          </a>
        </span>
      </div>

      <div class="fila">
        <span><label>Producto</label>{{ reserva.Producto }}</span>
        <span><label>Cantidad</label>{{ reserva.detalle.Cantidad }}</span>
      </div>

      <div class="fila">
        <span><label>Precio(Bs)</label>{{ reserva.detalle.PrecioUnitario }}</span>
        <span><label>Total(Bs)</label>{{ reserva.detalle.SubTotal }}</span>
      </div>

      <div class="fila">
        <span><label>Fecha de reserva</label>{{ obtenerFecha(reserva.detalle.Reserva.FechaSolicitud) }}</span>
        <span><label>Fecha de recojo</label>{{ obtenerFecha(reserva.detalle.Reserva.FechaEntrega) }}</span>
      </div>

      <div class="fila">
        <span>
          <label>Estado</label>
          <span [class]="obtenerColorEstado(reserva.detalle.Estado)" class="estado">
            {{obtenerEstadoReserva(reserva.detalle.Estado)}}
          </span>
        </span>
      </div>
    </div>

    <ng-template pTemplate="footer">
      <div class="flex gap-3 justify-content-center" *ngIf="reserva.detalle.Estado === '1'">
        <button pButton type="button" label="Confirmar" (click)="actualizarEstadoReserva(reserva, 'C')"
          class="btn"></button>
        <button pButton type="button" label="Rechazar" (click)="actualizarEstadoReserva(reserva, 'R')"
          class="btn"></button>
      </div>

      <div class="flex gap-3 justify-content-center"
        *ngIf="reserva.detalle.Estado !== '1' && reserva.detalle.Estado !== '3' && reserva.detalle.Estado !== '5' && reserva.detalle.Estado !== '6'">
        <button pButton type="button" label="{{reserva.detalle.Estado === '2' ? 'Listo para retirar' : 'Entregado'}}"
          (click)="actualizarEstadoReserva(reserva)" class="btn"></button>
      </div>
    </ng-template>
  </p-dialog>
</div>
